     H DFTACTGRP(*NO)

      /copy ifsio_h
      /copy usrspc_h
      /copy qmhljobl_h

     D UsrSpc          c                   'JOBLOGMSG QTEMP'
     D IfsFile         c                   '/tmp/joblog.txt'

     D Sel             ds                  likeds(JSLT0100_t)
     D Header          ds                  likeds(Qus_Generic_Header_0100_t)
     D                                     based(p_Header)
     D ApiHdr          ds                  likeds(QMHLJOBL_Header_t)
     D                                     based(p_ApiHdr)
     D Entry           ds                  likeds(LJOB0100_t)
     D                                     based(p_Entry)
     D Field           ds                  likeds(LJOB0100_field_t)
     D                                     based(p_Field)

     D CRLF            s              2A   inz(x'0d25')
     D x               s             10i 0
     D fd              s             10i 0

     D ErrorCode       ds                  qualified
     D   BytesProv                   10i 0 inz(0)
     D   BytesAvail                  10i 0 inz(0)

     D QCMDEXC         PR                  ExtPgm('QCMDEXC')
     D   cmd                        200A   const
     D   len                         15P 5 const

      /free

           //
           //  Delete user space if it exists (ignore errors)
           //

           ErrorCode.BytesProv = %size(ErrorCode);
           QUSDLTUS( UsrSpc: ErrorCode );

           //
           //  Create new user space to receive output
           //  and set pointer to that space
           //

           QUSCRTUS( UsrSpc
                   : 'JOBLOG2IFS'
                   : 100 * 1024
                   : x'00'
                   : '*ALL'
                   : 'List of Job Log Messages' );

           QUSPTRUS( UsrSpc: p_Header );

           //
           //  Create a stream file to contain result
           //  FIXME: This should do proper error checking!!
           //

           unlink(IFSFILE);
           fd = open( IFSFILE
                    : O_CREAT+O_CCSID+O_WRONLY
                    : M_RDWR
                    : 819 );
           callp close(fd);

           fd = open( IFSFILE : O_WRONLY + O_TEXTDATA );

           //
           //  List job log messages to user space
           //

           Sel.MaxMsgs    = -1;         // no maximum
           Sel.Dir        = '*NEXT';
           Sel.job        = '*';
           Sel.StrMsgKey  = *allx'00';
           Sel.MaxMsgLen  = 32765;
           Sel.MaxMsgHlp  = 0;
           Sel.FieldCount = 1;
           Sel.RtnFld(1)  = 302;        // msgs w/replacement data
           Sel.MsgQName   = '*';
           Sel.MsgQLen    = %len(%trimr(Sel.MsgQName));
           Sel.FieldIdOff = %addr(Sel.RtnFld) - %addr(Sel);
           Sel.MsgQOff    = %addr(Sel.MsgQName) - %addr(Sel);

           ErrorCode.BytesProv = 0;

           dou Header.InfoStatus = 'C';

               QMHLJOBL( UsrSpc
                       : 'LJOB0100'
                       : Sel
                       : %size(Sel)
                       : 'JSLT0100'
                       : ErrorCode );

               //
               //  Write job log messages to stdout
               //

               for x = 1 to Header.Count;

                    if (x = 1);
                      p_Entry = p_Header + Header.Offset;
                    else;
                      p_Entry = p_Header + Entry.Next;
                    endif;

                    p_Field = p_Header + Entry.fldOffset;

                    callp write(fd: %addr(Field.Data): Field.Len);
                    callp write(fd: %addr(CRLF): %size(CRLF));

                endfor;

                if (Header.InfoStatus = 'P');
                    p_ApiHdr = p_Header + Header.HeaderOffset;
                    Sel.StrMsgKey = ApiHdr.EndMsgKey;
                endif;

            enddo;

            callp close(fd);
            QUSDLTUS( UsrSpc: ErrorCode );

            QCMDEXC( 'DSPF ''' + IfsFile + '''' : 200);

            *inlr = *on;
      /end-free
